; Opera Loader 3.8 by A.Ruzanov
; 10.10.2006

#NoTrayIcon

Select
	Case FileExists(@ScriptDir & "\opkernel.exe") And @ScriptName <> "opkernel.exe"
		$VarOperaExe = @ScriptDir & "\opkernel.exe "
	Case FileExists(@ScriptDir & "\Opera.exe") And @ScriptName <> "Opera.exe"
		$VarOperaExe = @ScriptDir & "\Opera.exe "
	Case Else
		MsgBox(48, "Opera Loader Error", "Not exist Opera.exe and opkernel.exe", 5)
		Exit
EndSelect

$VarMark = 0

If IniRead(@ScriptDir & "\OperaDef6.ini", "System", "Multi User", "0") = 1 Then
	If MsgBox(49, "Opera Loader Error", "Found Multi User installation." & @CRLF & "Transform installation from multi-user to single-user?") = 1 Then
		$VarOpDir = StringSplit(@ScriptDir, "\")
		$NameDir = $VarOpDir[UBound($VarOpDir) - 1]
		$VarMultiMail = @AppDataDir & "\opera\" & $NameDir & "\mail"
		$VarMultiProfile = @AppDataDir & "\opera\" & $NameDir & "\profile"
		IniWrite(@ScriptDir & "\OperaDef6.ini", "System", "Multi User", "0")
		ToolTip("Please wait", 1, 1)
		DirMove($VarMultiMail, @ScriptDir & "\mail", 1)
		DirMove($VarMultiProfile, @ScriptDir & "\profile", 1)
		While FileExists($VarMultiMail) Or FileExists($VarMultiProfile)
			Sleep(500)
		WEnd
		$VarMark = 1
	Else
		MsgBox(48, "Opera Loader Error", "Opera Loader not work with Multi User installation. Exit.", 5)
		Exit
	EndIf
EndIf

$VarOperaDefDir = IniRead(@ScriptDir & "\OperaDef6.ini", "Install", "MAINDIR", "No")
$VarOperaDir = StringTrimRight(IniRead(@ScriptDir & "\profile\opera6.ini", "User Prefs", "Opera Directory", "No\profile"), 8)


Select
	Case $VarOperaDefDir = "No"
		MsgBox(48, "Opera Loader Error", "Not exist key ""MAINDIR"" in file:" & @CRLF & @CRLF & @ScriptDir & "\OperaDef6.ini", 5)
		Exit
	Case $VarOperaDir = "No"
		If MsgBox(49, "Opera Loader Error", "Not exist key ""Opera Directory"" in file:" & @CRLF & @CRLF & @ScriptDir & "\profile\Opera6.ini" & @CRLF & @CRLF & "Correct this?") = 1 Then
			If	$VarMark = 1 Then
				$VarOperaDir = @AppDataDir & "\opera\" & $NameDir
			Else
				$VarOperaDir = $VarOperaDefDir
			EndIf
			IniWrite(@ScriptDir & "\profile\opera6.ini", "User Prefs", "Opera Directory", $VarOperaDir & "\profile")
		Else
			Exit
		EndIf
EndSelect


EnvSet("operadir", @ScriptDir)
EnvSet("PATH", EnvGet("PATH") & ";" & @ScriptDir)

opt("WinTitleMatchMode", 2)
If WinExists("- Opera") And ProcessExists("opkernel.exe") Then
	WinActivate("- Opera")
EndIf

$TempDirUTF = StringToUTF(@TempDir)
$ScriptDirUTF = StringToUTF(@ScriptDir)


$VarOperaDef = @ScriptDir & "\operadef6.ini"
$VarOpera6 = @ScriptDir & "\profile\opera6.ini"
$VarWidgets = @ScriptDir & "\profile\widgets\widgets.dat"
$VarMailIndex = @ScriptDir & "\mail\index.ini"
$VarMailAccounts = @ScriptDir & "\mail\accounts.ini"
$VarOperaAdr = @ScriptDir & "\profile\opera6.adr"
$VarObook = @ScriptDir & "\profile\obook.ini"
$VarCorrect = 0

If $VarOperaDefDir <> $VarOperaDir And $VarMark = 0 Then
	If MsgBox(49, "Opera Loader Error", "Path different in OperaDef6.ini and Opera6.ini." & @CRLF & @CRLF & "Correct this?") <> 1 Then
		Exit
	EndIf
EndIf

$ScriptFileUTF = StringReplace($ScriptDirUTF, "\", "/")
$ScriptFileUTF = StringReplace($ScriptFileUTF, " ", "%20")

$VarOperaFile = StringReplace($VarOperaDir, "\", "/")
$VarOperaFile = StringReplace($VarOperaFile, " ", "%20")


If $VarOperaDir <> $ScriptDirUTF Or $VarOperaDefDir <> $ScriptDirUTF Then
	$VarCorrect = 1
	
	If FileExists($VarOperaDef) Then
		FileCopy($VarOperaDef, StringTrimRight($VarOperaDef, 3) & "bak", 1)
		ReplaceText($VarOperaDef, $VarOperaDefDir, $ScriptDirUTF)
	EndIf
	
	If FileExists($VarOpera6) Then
		FileCopy($VarOpera6, StringTrimRight($VarOpera6, 3) & "bak", 1)
		ReplaceText($VarOpera6, $VarOperaDir, $ScriptDirUTF)
	EndIf
	
	If FileExists(@ScriptDir & "\spellcheck.ini") Then IniWrite(@ScriptDir & "\spellcheck.ini", "Spell check", "Spell check engine", $ScriptDirUTF & "\spellcheck.dll")
	
	
	If IniRead(@ScriptDir & "\OperaLdr.ini", "Correct", "Menu", "0") <> 0 Then
		$VarSearchM = FileFindFirstFile(@ScriptDir & "\profile\menu\*.ini")
		If $VarSearchM <> - 1 Then
			While 1
				$VarOperaMenu = @ScriptDir & "\profile\menu\" & FileFindNextFile($VarSearchM)
				If @error Then ExitLoop
				FileCopy($VarOperaMenu, StringTrimRight($VarOperaMenu, 3) & "bak", 1)
				ReplaceText($VarOperaMenu, $VarOperaDir, $ScriptDirUTF)
			WEnd
			FileClose($VarSearchM)
		EndIf
	EndIf
	
	If IniRead(@ScriptDir & "\OperaLdr.ini", "Correct", "Toolbar", "0") <> 0 Then
		$VarSearchT = FileFindFirstFile(@ScriptDir & "\profile\toolbar\*.ini")
		If $VarSearchT <> - 1 Then
			While 1
				$VarOperaToolbar = @ScriptDir & "\profile\toolbar\" & FileFindNextFile($VarSearchT)
				If @error Then ExitLoop
				FileCopy($VarOperaToolbar, StringTrimRight($VarOperaToolbar, 3) & "bak", 1)
				ReplaceText($VarOperaToolbar, $VarOperaDir, $ScriptDirUTF)
			WEnd
			FileClose($VarSearchT)
		EndIf
	EndIf
	
	If IniRead(@ScriptDir & "\OperaLdr.ini", "Correct", "WidgetsPath", "1") <> 0 Then
		If FileExists($VarWidgets) Then
			FileCopy($VarWidgets, StringTrimRight($VarWidgets, 3) & "bak", 1)
			ReplaceText($VarWidgets, $VarOperaDir, $ScriptDirUTF)
		EndIf
	EndIf
	
	If IniRead(@ScriptDir & "\OperaLdr.ini", "Correct", "Mail", "1") <> 0 Then
		If FileExists($VarMailIndex) Then
			FileCopy($VarMailIndex, StringTrimRight($VarMailIndex, 3) & "bak", 1)
			ReplaceText($VarMailIndex, $VarOperaDir, $ScriptDirUTF)
		EndIf
		If FileExists($VarMailAccounts) Then
			FileCopy($VarMailAccounts, StringTrimRight($VarMailAccounts, 3) & "bak", 1)
			ReplaceText($VarMailAccounts, $VarOperaDir, $ScriptDirUTF)
		EndIf
	EndIf
	
	If IniRead(@ScriptDir & "\OperaLdr.ini", "Correct", "Obook", "0") <> 0 Then
		If FileExists($VarObook) Then
			FileCopy($VarObook, StringTrimRight($VarObook, 3) & "bak", 1)
			ReplaceText($VarObook, $VarOperaDir, $ScriptDirUTF)
		EndIf
	EndIf
	
	If IniRead(@ScriptDir & "\OperaLdr.ini", "Correct", "Bookmarks", "0") <> 0 Then
		If FileExists($VarOperaAdr) Then
			FileCopy($VarOperaAdr, StringTrimRight($VarOperaAdr, 4) & "_adr.bak", 1)
			ReplaceText($VarOperaAdr, $VarOperaFile, $ScriptFileUTF)
			ReplaceText($VarOperaAdr, $VarOperaDir, $ScriptDirUTF)
		EndIf
	EndIf
EndIf


If IniRead(@ScriptDir & "\OperaLdr.ini", "Correct", "Cache Directory", "1") <> 0 Then
	$VarDisk = StringSplit(String(@ScriptDir), "\")
	
	Select
		Case DriveGetType($VarDisk[1]) = "Removable" And $TempDirUTF & "\opera" <> IniRead(@ScriptDir & "\profile\opera6.ini", "User Prefs", "Cache Directory4", "No")
			IniWrite(@ScriptDir & "\profile\opera6.ini", "User Prefs", "Cache Directory4", $TempDirUTF & "\opera")
		Case DriveGetType($VarDisk[1]) <> "Removable" And $ScriptDirUTF & "\profile\cache4" <> IniRead(@ScriptDir & "\profile\opera6.ini", "User Prefs", "Cache Directory4", "No")
			IniWrite(@ScriptDir & "\profile\opera6.ini", "User Prefs", "Cache Directory4", $ScriptDirUTF & "\profile\cache4")
	EndSelect
	
EndIf

If IniRead(@ScriptDir & "\profile\opera6.ini", "User Prefs", "Search Type", "0") <> - 1 And IniRead(@ScriptDir & "\OperaLdr.ini", "Correct", "Search Type", "1") <> 0 Then
	IniWrite(@ScriptDir & "\profile\opera6.ini", "User Prefs", "Search Type", -1)
EndIf

If $VarCorrect = 1 Then
	StartProgram(@ScriptDir & "\OperaLdr.ini", "After correct")
EndIf

$VarCntr = StartProgram(@ScriptDir & "\OperaLdr.ini", "Program")


If $VarCntr = 0 Then
	Run($VarOperaExe & $CmdLineRaw, @ScriptDir)
Else
	RunWait($VarOperaExe & $CmdLineRaw, @ScriptDir)
	
	For $icl = 9 To 1 Step - 1
		If $VarCntr >= 2 ^ $icl Then
			$VarCntr = Mod($VarCntr, 2 ^ $icl)
			$VarClose = IniRead(@ScriptDir & "\OperaLdr.ini", "Program", "Close" & $icl, "")
			If $VarClose <> "" Then
				WinClose($VarClose)
			EndIf
		EndIf
	Next
EndIf


Exit


Func StringToUTF($String)
	Dim $sResult = ""
	$VarUTFArr = StringSplit($String, "")
	
	For $i = 1 To $VarUTFArr[0]
		$code = Asc($VarUTFArr[$i])
		
		Select
			Case $code >= 192 And $code <= 239
				$VarUTFArr[$i] = Chr(208) & Chr($code - 48)
			Case $code >= 240 And $code <= 255
				$VarUTFArr[$i] = Chr(209) & Chr($code - 112)
			Case $code = 168
				$VarUTFArr[$i] = Chr(208) & Chr(129)
			Case $code = 184
				$VarUTFArr[$i] = Chr(209) & Chr(145)
			Case Else
				$VarUTFArr[$i] = Chr($code)
		EndSelect
		
		$sResult = $sResult & $VarUTFArr[$i]
	Next
	
	Return $sResult
EndFunc   ;==>StringToUTF


Func ReplaceText($FileNameT, $OldText, $NewText)
	$hFile = FileOpen($FileNameT, 0)
	$aArray = StringSplit( FileRead($hFile, FileGetSize($FileNameT)), @LF)
	If Not @error Then
		FileClose($hFile)
		$hFilew = FileOpen($FileNameT, 2)
		For $iaar = 1 To $aArray[0] - 1
			$ReplStrT = StringReplace($aArray[$iaar], $OldText, $NewText)
			FileWrite($hFilew, $ReplStrT & @LF)
		Next
		FileClose($hFilew)
	EndIf
EndFunc   ;==>ReplaceText


Func StartProgram($VarIni, $VarSectionName)
	Dim $iResult = 0
	opt("RunErrorsFatal", 0)
	
	$VarErrorMsg = IniRead($VarIni, $VarSectionName, "Error Message", "1")
	For $ipr = 1 To 9
		
		$VarProgFlag = IniRead($VarIni, $VarSectionName, "Flag" & $ipr, "")
		$VarProgram = IniRead($VarIni, $VarSectionName, "Run" & $ipr, "")
		$VarProgram = StringReplace($VarProgram, "%operadir%", @ScriptDir)
		$VarProgram = StringReplace($VarProgram, "%TEMP%", @TempDir)
		$VarProgram = StringReplace($VarProgram, "%windir%", @WindowsDir)
		$VarProgram = StringReplace($VarProgram, "%ProgramFiles%", @ProgramFilesDir)
		$VarProgram = StringReplace($VarProgram, "%ComSpec%", @ComSpec)
		$VarProgram = StringReplace($VarProgram, "%MyDocuments%", @MyDocumentsDir)
		$VarArrName = StringSplit($VarProgram, "\")
		$VarName = UBound($VarArrName) - 1
		$VarArrNameFile = StringSplit($VarArrName[$VarName], " ")
		If $VarProgram <> "" And Not ProcessExists($VarArrNameFile[1]) Then
			$VarWorkDir = StringTrimRight($VarProgram, StringLen($VarArrName[$VarName]) + 1)
			If Not FileExists($VarWorkDir) Then $VarWorkDir = ""
			Select
				Case $VarProgFlag = "HIDE"
					Run($VarProgram, $VarWorkDir, @SW_HIDE)
					
				Case $VarProgFlag = "MINIMIZE"
					Run($VarProgram, $VarWorkDir, @SW_MINIMIZE)
					
				Case $VarProgFlag = "MAXIMIZE"
					Run($VarProgram, $VarWorkDir, @SW_MAXIMIZE)
					
				Case Else
					Run($VarProgram, $VarWorkDir)
			EndSelect
			
			If @error Then
				If $VarErrorMsg <> 0 Then
					MsgBox(48, "Opera Loader Error", "Can't start " & $VarProgram, 5)
				EndIf
			Else
				$iResult = $iResult + 2 ^ $ipr
			EndIf
		EndIf
	Next
	
	Return $iResult
EndFunc   ;==>StartProgram